=== po/CMakeLists.txt ===
IF(ENABLE_WX)
  add_subdirectory(wxvbam)
ENDIF(ENABLE_WX)
